/*
 * Copyright (C) 2010 Timo Kokkonen <kaapeli@itanic.dy.fi>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _BINTREE_H
#define _BINTREE_H

struct bintree {
	struct bintree *left, *right;
};

struct bintree_ops {
	int (*compare)(struct bintree *a, struct bintree *b);
	void (*callback)(struct bintree *tree, struct bintree_ops *ops);
};

struct bintree *bintree_add(struct bintree *tree, struct bintree *new,
			struct bintree_ops *ops);
struct bintree *bintree_find(struct bintree *tree, struct bintree *new,
			struct bintree_ops *ops);
int bintree_walk(struct bintree *tree, struct bintree_ops *ops);

#endif
